﻿
namespace Common.Log
{
    /// <summary>
    /// Gestor de logs de la aplicación
    /// </summary>
    public class LogFactory
    {
        private static log4net.ILog logGestor;

        /// <summary>
        /// Inicializa el gestor leyendo los parámetros de configuración
        /// </summary>
        private static void Inicializar()
        {
            log4net.Config.XmlConfigurator.Configure();
            logGestor = log4net.LogManager.GetLogger("File");
            Cabecera();
        }

        /// <summary>
        /// Escribe una cabecera
        /// </summary>
        private static void Cabecera()
        {
            logGestor.Info("------------ INICIANDO APLICACION ------------");
        }

        /// <summary>
        /// Obtiene el objeto que escribirá el log
        /// </summary>
        /// <returns>Objeto que escribe el log</returns>
        public static log4net.ILog Escribir()
        {
            if (logGestor == null)
            {
                Inicializar();
            }
            return logGestor;
        }
    }
}