﻿using System;
using System.Configuration;

namespace EntornoWeb.Common
{
    /// <summary>
    /// Constantes internas de la aplicación
    /// </summary>
    public static class Constants
    {
        private static AppSettingsReader objLector;

        /// <summary>
        /// Resultado del test en caso de no haber error
        /// </summary>
        public const String STR_TESTING_CODIGO_OK = "-0- OK";

        /// <summary>
        /// Resultado del test en caso de haber error
        /// </summary>
        public const String STR_TESTING_CODIGO_ERROR = "-1- Error al acceder a base de datos";

        /// <summary>
        /// Ubicación por defecto para sesiones presenciales
        /// </summary>
        public const string STR_ALTA_NUEVA_SESION_PRESENCIAL = "Pendiente definir ubicación";
        
        /// <summary>
        /// Ubicación por defecto para sesiones no presenciales
        /// </summary>
        public const string STR_ALTA_NUEVA_SESION_NO_PRESENCIAL = "Curso no presencial";
        
        /// <summary>
        /// Correspondencia Si-True
        /// </summary>
        public const string STR_VERDADERO = "Si";
        
        /// <summary>
        /// Correspondencia No-No
        /// </summary>
        public const string STR_FALSO = "No";

        /// <summary>
        /// Literal que representa la ordenación ascendente
        /// </summary>
        public const string STR_ORDENACION_ASCENDENTE = "asc";

        /// <summary>
        /// Literal que representa la ordenación descendente
        /// </summary>
        public const string STR_ORDENACION_DESCENDENTE = "des";
               
        /// <summary>
        /// Obtiene el lector que examina las propiedades de la aplicacion definidas en el web.config
        /// </summary>
        /// <returns>Lector de propiedades</returns>
        private static AppSettingsReader getLector()
        {
            if (objLector == null) {
                objLector = new AppSettingsReader();
            }
            return objLector;
        }

        /// <summary>
        /// Versión actual de la aplicación
        /// </summary>
        public static String VersionAplicacion
        {
            get
            {
                return (String) getLector().GetValue("VersionAplicacion", typeof(String));
            }
        }

        /// <summary>
        /// Link del correo electrónico del autor
        /// </summary>
        public static String LinkSoporte
        {
            get
            {
                return (String)getLector().GetValue("LinkSoporte", typeof(String));
            }
        }

        /// <summary>
        /// Link a los informes de report server
        /// </summary>
        public static String LinkReportServer
        {
            get
            {
                return (String)getLector().GetValue("LinkReportServer", typeof(String));
            }
        }

    }
}