﻿using System.Globalization;
using System.Text;

namespace EntornoWeb.Common
{
    /// <summary>
    /// Utilidades necesarias en cualquier punto de la aplicación web
    /// </summary>
    public class Utilities
    {
        /// <summary>
        /// Normaliza una cadena de texto en caracteres unicode, sustituyento aquellos que no son standart
        /// </summary>
        /// <param name="strOriginal">Cadena sin normalizar</param>
        /// <returns>Cadena normalizada</returns>
        public static string NormalizarCadena(string strOriginal)
        {
            string strNormalizado = strOriginal.Normalize(NormalizationForm.FormD);
            StringBuilder sbdBuffer = new StringBuilder();
            for (int i = 0; i < strNormalizado.Length; i++)
            {
                UnicodeCategory uc = CharUnicodeInfo.GetUnicodeCategory(strNormalizado[i]);
                if (uc != UnicodeCategory.NonSpacingMark)
                {
                    sbdBuffer.Append(strNormalizado[i]);
                }
            }
            return (sbdBuffer.ToString().Normalize(NormalizationForm.FormC));
        }
    }
}