﻿using System;
using System.Web;

namespace EntornoWeb.Models
{
    /// <summary>
    /// Módulo de autenticación del usuario
    /// </summary>
    public class Autenticacion : IHttpModule
    {
        HttpApplication _context;

        /// <summary>
        /// Inicialización del módulo
        /// </summary>
        /// <param name="context">Contexto http</param>
        public void Init(HttpApplication context)
        {
            _context = context;
            context.EndRequest += new EventHandler(CheckStatus);
            //context.Error += new EventHandler(CheckStatus);
        }

        /// <summary>
        /// Validación del código de la respuesta
        /// </summary>
        /// <param name="sender">Emisor de la petición</param>
        /// <param name="e">Argumentos de la petición</param>
        private void CheckStatus(object sender, EventArgs e)
        {
            if ((_context.Response.StatusCode != 200) && (_context.Response.StatusCode != 302) && (_context.Response.StatusCode != 500))
            {
                _context.Response.RedirectToRoute("Default", new { controller = "Error", action = "ErrorEndRequest", id = _context.Response.Status });
            }
        }

        /// <summary>
        /// Liberación de los recursos
        /// </summary>
        public void Dispose() { }
    }
}