﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder_Title" runat="server">
    Sistema para la Gestión de la Formación - Colectivos
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder_Main" runat="server">
    <div id="div_contenedor">

    <div id="div_padre">
    <table id="grid_padre"></table>
    <div id="paginador_padre"></div>
    </div>
    <script type="text/javascript" language="javascript">
        var varibleGlobal = this;
        varibleGlobal.colectivo = 0;

        function almacenarColectivo(colectivoActual) {
            varibleGlobal.colectivo = colectivoActual;
        }

        function obtenerColectivo() {
            return varibleGlobal["colectivo"];
        }

        function padreSelectRow(rowid) {
            almacenarColectivo(rowid);
            refrescarGridsHijos();
        }

        function padreLoadComplete() {
            almacenarColectivo(0);
            refrescarGridsHijos();
        }

        function refrescarGridsHijos() {
            if ($('#div_hijos').is(':visible')) {
                refrescarGridHijo($('#grid_hijos_asignados'));
                refrescarGridHijo($('#grid_hijos_noasignados'));
            }
        }

        function refrescarGridHijo(grid) {
            grid.setGridParam({ postData: { colectivoActual: obtenerColectivo() }, datatype: 'json' }).trigger('reloadGrid');
        }

        function expandirHijo() {
            if ($('#div_hijos').is(':hidden')) {
                document.getElementById("div_hijos").style.visibility = "visible";
                refrescarGridHijo($('#grid_hijos_asignados'));
                refrescarGridHijo($('#grid_hijos_noasignados'));
                jQuery("#grid_hijos_asignados").setGridState('visible');
                jQuery("#grid_hijos_noasignados").setGridState('visible');
                jQuery("#div_hijos").show("slow");
            }
            else {
                jQuery("#grid_hijos_asignados").setGridState('hidden');
                jQuery("#grid_hijos_noasignados").setGridState('hidden');
                jQuery("#div_hijos").hide("slow");
            }
        }
        
        var addOptions = {
            width: 500,
            closeAfterAdd: true,
            closeOnEscape: true,
            savekey: [true, 13],
            height: "auto",
            beforeShowForm: function (form) { $('#EsOcupacion', form).removeAttr('disabled'); },
        }

        var editOptions = {
            width: 500,
            closeAfterEdit: true,
            closeOnEscape: true,
            savekey: [true, 13],
            height: "auto",
            beforeShowForm: function (form) { $('#EsOcupacion', form).attr('disabled', 'disabled'); }
        }

        var deleteOptions = {
            width: 500,
            closeAfterDel: true,
            closeOnEscape: true,
            savekey: [true, 13],
            height: "auto",
            beforeSubmit: colectivoValidarDel 
        }

        function colectivoValidarDel(postdata, formid) {
            var resultado = true;
            var mensaje = '';
            $.ajax({
                async: false,
                type: 'POST',
                url: '<%= Url.Action("ColectivoValidarDel") %>',
                data: { colectivoIdint: obtenerColectivo() },
                success: function (data, textStatus, XMLHttpRequest) {
                },
                error: function (request, status, error) { resultado = false; mensaje = request.responseText; }
            });
            return [resultado, mensaje];
        }

        var searchOptions = {
            closeOnEscape: true,
            closeAfterSearch: true,
            beforeShowSearch: function (form) { form.keydown(function (e) { if (e.which == 13) { $(".ui-search", form).click(); } }); },
            multipleSearch: false
        }

        function longitudColectivoDescripcion(value, colname) {
            var max = 300;
            var campo = 'descripción';
            if (value.length > max)
                return [false, 'INFORMACIÓN: El campo ' + campo + ' no debe superar los ' + max + ' caracteres'];
            else
                return [true, ''];
        }

        jQuery(document).ready(function () {
            jQuery("#grid_padre").jqGrid({
                url: '<%= Url.Action("ObtenerColectivos") %>',
                editurl: '<%= Url.Action("EditarColectivo") %>',
                datatype: 'json',
                mtype: 'POST',
                colNames: ['Colectivo', 'Descripción', 'Ocupación'],
                colModel: [
                { name: 'Nombre', index: 'Nombre', edittype: 'text', align: 'left', editable: true, editoptions: { size: '60', maxlength: '25' }, editrules: { required: true }, searchoptions: { sopt: ['cn']} },
                { name: 'Descripcion', index: 'Descripcion', edittype: 'textarea', align: 'left', editable: true, editoptions: { rows: '5', cols: '60' }, editrules: { required: false, custom: true, custom_func: longitudColectivoDescripcion }, searchoptions: { sopt: ['cn']} },
                { name: 'EsOcupacion', index: 'EsOcupacion', edittype: 'checkbox', width: 25, align: 'center', editable: true, editoptions: { value: "True:False" }, editrules: { required: false }, formatter: "checkbox", formatoptions: { disabled: true}, search: false }
                ],
                pager: jQuery('#paginador_padre'),
                rowNum: 10,
                rowList: [10, 25, 50, 100, 1000],
                sortname: 'Nombre',
                sortorder: 'asc',
                viewrecords: true,
                //scrollOffset: 0,    //No reserva espacio para el scroll vertical
                imgpath: '/Content/jqgrid/images',
                caption: 'Listado de Colectivos',
                //height: '100%',
                height: '231',
                autowidth: true,
                ondblClickRow: function (row_id, iRow, iCol, e) { jQuery('#grid_padre').editGridRow(row_id, editOptions); },
                onSelectRow: padreSelectRow,
                loadComplete: padreLoadComplete,
                loadError: function () { window.location = "/Home/ErrorEndRequest" }
            }).navGrid('#paginador_padre', { search: true, edit: true, add: true, del: true, refresh: true, searchtext: '' }, editOptions, addOptions, deleteOptions, searchOptions);
            jQuery("#grid_padre").jqGrid('navButtonAdd', '#paginador_padre', { caption: "Empleados del colectivo", onClickButton: expandirHijo });
            jQuery("#div_hijos").hide();
        })

    </script> 

    <div id="div_hijos" style="visibility:hidden">
    &nbsp;
    <table width="100%">
        <tr>
            <td>
                <table width="20">
                </table>
            </td>
            <td>
                <table id="grid_hijos_asignados"></table>
                <div id="paginador_hijos_asignados"></div>
            </td>
            <td>
                <table width="40">
                </table>
            </td>
            <td>
                <table id="grid_hijos_noasignados"></table>
                <div id="paginador_hijos_noasignados"></div>
            </td>
        </tr>
    </table>
    </div>
    <script type="text/javascript" language="javascript">
        desasignarEmpleado = function (rowId) {
            $('#desasignar' + rowId).hide("slow");
            $.ajax({
                type: 'POST',
                url: '<%= Url.Action("DesasignarEmpleado") %>',
                data: { empleadoIdint: rowId, colectivoIdint: obtenerColectivo() },
                success: function (data, textStatus, XMLHttpRequest) {
                    refrescarGridsHijos();
                },
                error: function (request, status, error) { alert(request.responseText); }
            });
        };
        
        function insertarBotonDesasignar() {
            var grid = jQuery("#grid_hijos_asignados");
            var ids = grid.jqGrid('getDataIDs');
            for (var i = 0; i < ids.length; i++) {
                var rowId = ids[i];
                var checkOut = "<img id='desasignar" + rowId + "' src='/Content/images/flecha_derecha.png' style='height:20px;width:20px;' onclick=\"desasignarEmpleado(" + rowId + ");\" />";
                grid.jqGrid('setRowData', rowId, { action: checkOut });
            };
        }

        function completarParametros() {
            return { colectivoActual: obtenerColectivo() };
        }

        var editFechaAsignacion = {
            width: 500,
            closeAfterEdit: true,
            closeOnEscape: true,
            savekey: [true, 13],
            height: "auto",
            onInitializeForm: function () {
                $('#Asignacion').datepicker({ showButtonPanel: true, changeMonth: true, changeYear: true });
            }
        }

        jQuery(document).ready(function () {
            jQuery("#grid_hijos_asignados").jqGrid({
                caption: 'Empleados asignados al colectivo seleccionado',
                url: '<%= Url.Action("ObtenerEmpleadosAsignados") %>',
                editurl: '<%= Url.Action("EditarAsignacion") %>',
                datatype: 'json',
                mtype: 'POST',
                colNames: ['ColectivoIdint', 'DNI', 'Nombre', 'Apellidos', 'Empleado', 'F.Asignación', 'DeBaja', ''],
                colModel: [
                { name: 'ColectivoIdint', index: 'ColectivoIdint', editable: true, hidden: true },
                { name: 'DNI', index: 'DNI', width: 7, align: 'center', sortable: true, searchoptions: { sopt: ['cn']} },
                { name: 'Nombre', index: 'Nombre', width: 0, align: 'center', hidden: true, sortable: true, searchoptions: { sopt: ['cn'], searchhidden: true} },
                { name: 'Apellidos', index: 'Apellidos', width: 0, align: 'center', hidden: true, sortable: true, searchoptions: { sopt: ['cn'], searchhidden: true} },
                { name: 'Empleado', index: 'Empleado', edittype: 'text', width: 20, align: 'left', search: false, editable: false, editoptions: { size: "20", maxlength: "30" }, editrules: { edithidden: true, required: true }, searchoptions: { sopt: ['cn']} },
                { name: 'Asignacion', index: 'Asignacion', width: 7, align: 'center', sortable: true, editable: true, editoptions: { size: "20", maxlength: "30" }, editrules: { required: true, date: true }, datefmt: 'dd/mm/yyyy', search: false },
                { name: 'DeBaja', index: 'DeBaja', edittype: 'text', hidden: true, editable: false, editrules: { edithidden: true, required: true, date: true} },
                { name: 'action', index: 'action', width: 2, align: 'center', sortable: false, search: false }
                ],
                pager: jQuery('#paginador_hijos_asignados'),
                rowNum: 10,
                rowList: [10, 25, 50, 100, 1000],
                sortname: 'Empleado',
                sortorder: 'asc',
                viewrecords: true,
                //scrollOffset: 0,    //No reserva espacio para el scroll vertical
                imgpath: '/Content/jqgrid/images',
                height: 231,
                //autowidth: true,
                width: 450,
                hiddengrid: true,
                multiselect: false,
                //rowList: false,
                //pgbuttons: false,
                //pgtext: null,
                viewrecords: false,
                afterInsertRow: function (rowid, rowdata) { if (rowdata.DeBaja == 'Si') { $(this).jqGrid('setRowData', rowid, false, { color: 'Tomato' }); } },
                ondblClickRow: function (row_id, iRow, iCol, e) { jQuery('#grid_hijos_asignados').editGridRow(row_id, editFechaAsignacion); },
                gridComplete: insertarBotonDesasignar,
                loadError: function () { window.location = "/Home/ErrorEndRequest" }
            }).navGrid('#paginador_hijos_asignados', { search: true, edit: true, add: false, del: false, refresh: true, searchtext: '' }, editFechaAsignacion, addOptions, deleteOptions, searchOptions);
        })
    </script>
    <script type="text/javascript" language="javascript">
        asignarEmpleado = function (rowId) {
            $('#asignar' + rowId).hide("slow");
            $.ajax({
                type: 'POST',
                url: '<%= Url.Action("AsignarEmpleado") %>',
                data: { empleadoIdint: rowId, colectivoIdint: obtenerColectivo() },
                success: function (response) {
                    refrescarGridsHijos();
                },
                error: function (request, status, error) { alert(request.responseText); }
            });
        };

        function insertarBotonAsignar() {
            var grid = jQuery("#grid_hijos_noasignados");
            var ids = grid.jqGrid('getDataIDs');
            for (var i = 0; i < ids.length; i++) {
                var rowId = ids[i];
                var checkOut = "<img id='asignar" + rowId + "' src='/Content/images/flecha_izquierda.png' style='height:20px;width:20px;' onclick=\"asignarEmpleado(" + rowId + ");\" />";
                grid.jqGrid('setRowData', rowId, { action: checkOut });
            }
        }
        
        jQuery(document).ready(function () {
            jQuery("#grid_hijos_noasignados").jqGrid({
                url: '<%= Url.Action("ObtenerEmpleadosAsignadosDistintoColectivo") %>',
                datatype: 'json',
                mtype: 'POST',
                colNames: ['', 'DNI', 'Nombre', 'Apellidos', 'Empleado', 'DeBaja'],
                colModel: [
                { name: 'action', index: 'action', width: 2, align: 'center', sortable: false, search: false },
                { name: 'DNI', index: 'DNI', width: 8, align: 'center', sortable: true, searchoptions: { sopt: ['cn']} },
                { name: 'Nombre', index: 'Nombre', width: 0, align: 'center', hidden: true, sortable: true, searchoptions: { sopt: ['cn'], searchhidden: true} },
                { name: 'Apellidos', index: 'Apellidos', width: 0, align: 'center', hidden: true, sortable: true, searchoptions: { sopt: ['cn'], searchhidden: true} },
                { name: 'Empleado', index: 'Empleado', edittype: 'text', width: 25, align: 'left', search: false, editable: false, editoptions: { size: "20", maxlength: "30" }, editrules: { edithidden: true, required: true }, searchoptions: { sopt: ['cn']} },
                { name: 'DeBaja', index: 'DeBaja', edittype: 'text', width: 0, hidden: true, editable: false, editrules: { edithidden: true, required: true, date: true} }
                ],
                pager: jQuery('#paginador_hijos_noasignados'),
                rowNum: 10,
                rowList: [10, 25, 50, 100, 1000, 3000],
                sortname: 'Empleado',
                sortorder: 'asc',
                viewrecords: true,
                //scrollOffset: 0,    //No reserva espacio para el scroll vertical
                imgpath: '/Content/jqgrid/images',
                caption: 'Empleados NO asignados al colectivo seleccionado',
                height: 231,
                //autowidth: true,
                width: 450,
                hiddengrid: true,
                multiselect: false,
                //rowList: false,
                //pgbuttons: false,
                //pgtext: null,
                viewrecords: false,
                afterInsertRow: function (rowid, rowdata) { if (rowdata.DeBaja == 'Si') { $(this).jqGrid('setRowData', rowid, false, { color: 'Tomato' }); } },
                gridComplete: insertarBotonAsignar,
                loadError: function () { window.location = "/Home/ErrorEndRequest" }
            }).navGrid('#paginador_hijos_noasignados', { search: true, edit: false, add: false, del: false, refresh: true, searchtext: '' }, editOptions, addOptions, deleteOptions, searchOptions);
        })
    </script>

    </div>
</asp:Content>


