﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder_Title" runat="server">
    Sistema para la Gestión de la Formación - Cursos
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder_Main" runat="server">
    <div id="div_contenedor">

    <div id="div_padre">
    <table id="grid_padre"></table>
    <div id="paginador_padre"></div>
    </div>
    <script type="text/javascript" language="javascript">
        var varibleGlobal = this;
        varibleGlobal.curso = 0;

        function almacenarCurso(cursoActual) {
            varibleGlobal.curso = cursoActual;
        }

        function obtenerCurso() {
            return varibleGlobal["curso"];
        }

        function padreSelectRow(rowid) {
            almacenarCurso(rowid);
            refrescarGridsHijos();
        }

        function padreLoadComplete() {
            almacenarCurso(0);
            refrescarGridsHijos();
        }

        function refrescarGridsHijos() {
            if ($('#div_hijos1').is(':visible')) {
                refrescarGridHijo($('#grid_hijos1_asignados'));
                refrescarGridHijo($('#grid_hijos1_noasignados'));
            }
            if ($('#div_hijos2').is(':visible')) {
                refrescarGridHijo($('#grid_hijos2_asignados'));
                refrescarGridHijo($('#grid_hijos2_noasignados'));
            }
        }

        function refrescarGridHijo(grid) {
            grid.setGridParam({ postData: { cursoActual: obtenerCurso() }, datatype: 'json' }).trigger('reloadGrid');
        }

        function expandirHijo1() {
            if ($('#div_hijos1').is(':hidden')) {
                document.getElementById("div_hijos1").style.visibility = "visible";
                refrescarGridHijo($('#grid_hijos1_asignados'));
                refrescarGridHijo($('#grid_hijos1_noasignados'));
                jQuery("#grid_hijos1_asignados").setGridState('visible');
                jQuery("#grid_hijos1_noasignados").setGridState('visible');
                jQuery("#div_hijos1").show("slow");
                jQuery("#div_hijos2").hide("slow");
            } 
            else { 
                jQuery("#grid_hijos1_asignados").setGridState('hidden');
                jQuery("#grid_hijos1_noasignados").setGridState('hidden');
                jQuery("#div_hijos1").hide("slow");
            }
        }

        function expandirHijo2() {
            if ($('#div_hijos2').is(':hidden')) {
                document.getElementById("div_hijos2").style.visibility = "visible";
                refrescarGridHijo($('#grid_hijos2_asignados'));
                refrescarGridHijo($('#grid_hijos2_noasignados'));
                jQuery("#grid_hijos2_asignados").setGridState('visible');
                jQuery("#grid_hijos2_noasignados").setGridState('visible');
                jQuery("#div_hijos2").show("slow");
                jQuery("#div_hijos1").hide("slow");
            }
            else {
                jQuery("#grid_hijos2_asignados").setGridState('hidden');
                jQuery("#grid_hijos2_noasignados").setGridState('hidden');
                jQuery("#div_hijos2").hide("slow");
            }
        }
        
        var addOptions = {
            width: 500,
            closeAfterAdd: true,
            closeOnEscape: true,
            savekey: [true, 13],
            height: "auto"
        }

        var editOptions = {
            width: 500,
            closeAfterEdit: true,
            closeOnEscape: true,
            savekey: [true, 13],
            height: "auto",
            beforeShowForm: function (form) { $('#TipoVersion', form).attr('disabled', 'disabled'); },
            onInitializeForm: function () { $('#Fecha').datepicker({ showButtonPanel: true, changeMonth: true, changeYear: true }); }
        }

        var deleteOptions = {
            width: 500,
            closeAfterDel: true,
            closeOnEscape: true,
            savekey: [true, 13],
            height: "auto"
        }

        var searchOptions = {
            closeOnEscape: true,
            closeAfterSearch: true,
            beforeShowSearch: function (form) { form.keydown(function (e) { if (e.which == 13) { $(".ui-search", form).click(); } }); },
            //onClose: function (form) { form.unbind('keydown'); },
            multipleSearch: false
        }

        function longitudCursoDescripcion(value, colname) {
            var max = 300;
            var campo = 'descripción';
            if (value.length > max)
                return [false, 'INFORMACIÓN: El campo ' + campo + ' no debe superar los ' + max + ' caracteres'];
            else
                return [true, ''];
        }

        jQuery(document).ready(function () {
            jQuery("#grid_padre").jqGrid({
                url: '<%= Url.Action("ObtenerCursos") %>',
                editurl: '<%= Url.Action("EditarCurso") %>',
                datatype: 'json',
                mtype: 'POST',
                colNames: ['Nombre', 'Descripción', 'Tipo', 'Incorporación', 'Periodicidad', 'Repetir por nueva versión'],
                colModel: [
                { name: 'Nombre', index: 'Nombre', edittype: 'text', width: 25, align: 'left', editable: true, editoptions: { size: '51', maxlength: '25' }, editrules: { required: true }, sortable: true, searchoptions: { sopt: ['cn']} },
                { name: 'Descripcion', index: 'Descripcion', edittype: 'textarea', width: 30, align: 'left', editable: true, editoptions: { rows: '5', cols: '50' }, editrules: { required: false, custom: true, custom_func: longitudCursoDescripcion }, searchoptions: { sopt: ['cn']} },
                { name: 'Tipo', index: 'Tipo', edittype: 'text', width: 7, align: 'center', editable: true, edittype: 'select', editoptions: { value: { 1: 'Central', 2: 'Local', 3: 'Otros'} }, editrules: { required: true }, searchoptions: { sopt: ['eq']} },
                { name: 'IncorporacionMeses', index: 'IncorporacionMeses', edittype: 'text', width: 10, align: 'center', editable: true, editoptions: { size: "7", maxlength: "3" }, editrules: { required: false, number: true, minValue: 0 }, searchoptions: { sopt: ['eq'] }, formoptions: { elmsuffix: 'meses (0 = Sin límite)'} },
                { name: 'PeriodicidadMeses', index: 'PeriodicidadMeses', edittype: 'text', width: 10, align: 'center', editable: true, editoptions: { size: "7", maxlength: "3" }, editrules: { required: false, number: true, minValue: 0 }, searchoptions: { sopt: ['eq'] }, formoptions: { elmsuffix: 'meses (0 = Sin periodicidad)'} },
                { name: 'RepetirConNuevaVersion', index: 'RepetirConNuevaVersion', edittype: 'checkbox', width: 10, align: 'center', editable: true, editoptions: { value: "True:False" }, editrules: { required: false }, formatter: "checkbox", formatoptions: { disabled: true }, search: false }
                ],
                pager: jQuery('#paginador_padre'),
                rowNum: 10,
                rowList: [10, 25, 50, 100, 1000],
                sortname: 'Nombre',
                sortorder: 'asc',
                viewrecords: true,
                imgpath: '/Content/jqgrid/images',
                caption: 'Listado de Cursos',
                //height: '100%',
                height: '231',
                autowidth: true,
                ondblClickRow: function (row_id, iRow, iCol, e) { jQuery('#grid_padre').editGridRow(row_id, editOptions); },
                onSelectRow: padreSelectRow,
                loadComplete: padreLoadComplete,
                loadError: function () { window.location = "/Home/ErrorEndRequest" }
            }).navGrid('#paginador_padre', { search: true, edit: true, add: true, del: true, refresh: true, searchtext: '' }, editOptions, addOptions, deleteOptions, searchOptions);
            jQuery("#grid_padre").jqGrid('navButtonAdd', '#paginador_padre', { caption: "Versiones", onClickButton: expandirHijo1 });
            jQuery("#grid_padre").jqGrid('navButtonAdd', '#paginador_padre', { caption: "Planificaciones", onClickButton: expandirHijo2 });
            jQuery("#div_hijos1").hide();
            jQuery("#div_hijos2").hide();
        })

    </script> 

    <div id="div_hijos1" style="visibility:hidden">
    &nbsp;
    <table width="100%">
        <tr>
            <td>
                <table width="20">
                </table>
            </td>
            <td>
                <table id="grid_hijos1_asignados"></table>
                <div id="paginador_hijos1_asignados"></div>
            </td>
            <td>
                <table width="40">
                </table>
            </td>
            <td>
                <table id="grid_hijos1_noasignados"></table>
                <div id="paginador_hijos1_noasignados"></div>
            </td>
        </tr>
    </table>
    </div>
    <script type="text/javascript" language="javascript">
        var addOptionsVersionManual = {
            caption: '',
            buttonicon: 'ui-icon-plus',
            position: 'first',
            closeAfterAdd: true,
            closeOnEscape: true,
            savekey: [true, 13],
            height: "auto",
            width: 500,
            beforeShowForm: function (form) { $('#TipoVersion', form).removeAttr('disabled'); },
            beforeSubmit: function (postdata, formid) {
                if (obtenerCurso() == 0) {
                    return [false, 'Seleccione el curso al que desea asociar la versión'];
                }
                else {
                    postdata.CursoIdint = obtenerCurso();
                    return [true];
                }
            }
        }

        eliminarTemario = function (rowId) {
            if (confirm("¿Seguro que desea eliminar el temario?")) {
                $.ajax({
                    type: 'POST',
                    url: '<%= Url.Action("FicheroEliminar") %>',
                    data: { versionActual: rowId, tipo: 'Temario' },
                    success: function (data, textStatus, XMLHttpRequest) {
                        jQuery("#grid_hijos1_asignados").trigger('reloadGrid');
                        alert('Temario eliminado');
                    },
                    error: function (req, status, error) { alert('Error recuperando datos'); }
                });
            }
        };

        eliminarFicha = function (rowId) {
            if (confirm("¿Seguro que desea eliminar la ficha?")) {
                $.ajax({
                    type: 'POST',
                    url: '<%= Url.Action("FicheroEliminar") %>',
                    data: { versionActual: rowId, tipo: 'Ficha' },
                    success: function (data, textStatus, XMLHttpRequest) {
                        jQuery("#grid_hijos1_asignados").trigger('reloadGrid');
                        alert('Ficha eliminada');
                    },
                    error: function (req, status, error) { alert('Error recuperando datos'); }
                });
            }
        };

        function insertarBotonesFirmas() {
            var grid = jQuery("#grid_hijos1_asignados");
            var ids = grid.jqGrid('getDataIDs');
            for (var i = 0; i < ids.length; i++) {
                var rowId = ids[i];

                var checkOut = "<div id='file-uploaderT" + rowId + "' title='Asociar temario'></div>";
                grid.jqGrid('setRowData', rowId, { TI: checkOut });
                checkOut = "<div id='file-uploaderF" + rowId + "' title='Asociar ficha'></div>";
                grid.jqGrid('setRowData', rowId, { FI: checkOut });

                if (grid.jqGrid('getCell', rowId, 'TC') == "true") {
                    checkOut = "<img src='/Content/images/documento_ver.png' alt='Consultar temario' onclick=\"window.open('Firmas/" + rowId + "?tipo=Temario');\" />";
                    grid.jqGrid('setRowData', rowId, { TC: checkOut });
                }
                else {
                    grid.jqGrid('setCell', rowId, 'TC', ' ');
                }
                if (grid.jqGrid('getCell', rowId, 'FC') == "true") {
                    checkOut = "<img src='/Content/images/documento_ver.png' alt='Consultar temario' onclick=\"window.open('Firmas/" + rowId + "?tipo=Ficha');\" />";
                    grid.jqGrid('setRowData', rowId, { FC: checkOut });
                }
                else {
                    grid.jqGrid('setCell', rowId, 'FC', ' ');
                }

                if (grid.jqGrid('getCell', rowId, 'TE') == "true") {
                    checkOut = "<img src='/Content/images/documento_eliminar.png' alt='Eliminar temario' onclick=\"eliminarTemario(" + rowId + ");\" />";
                    grid.jqGrid('setRowData', rowId, { TE: checkOut });
                }
                else {
                    grid.jqGrid('setCell', rowId, 'TE', ' ');
                }
                if (grid.jqGrid('getCell', rowId, 'FE') == "true") {
                    checkOut = "<img src='/Content/images/documento_eliminar.png' alt='Eliminar ficha' onclick=\"eliminarFicha(" + rowId + ");\" />";
                    grid.jqGrid('setRowData', rowId, { FE: checkOut });
                }
                else {
                    grid.jqGrid('setCell', rowId, 'FE', ' ');
                }

                var uploaderT = new qq.FileUploader({
                    element: document.getElementById('file-uploaderT' + rowId),
                    action: '/MCursos/Upload/' + rowId,
                    params: { tipo: 'Temario' },
                    onComplete: function (id, fileName, responseJSON) {
                        jQuery("#grid_hijos1_asignados").trigger('reloadGrid');
                        alert('Temario almacenado');
                    }
                });
                var uploaderF = new qq.FileUploader({
                    element: document.getElementById('file-uploaderF' + rowId),
                    action: '/MCursos/Upload/' + rowId,
                    params: { tipo: 'Ficha' },
                    onComplete: function (id, fileName, responseJSON) {
                        jQuery("#grid_hijos1_asignados").trigger('reloadGrid');
                        alert('Ficha almacenada');
                    }
                });
            }
        }

        jQuery(document).ready(function () {
            jQuery("#grid_hijos1_asignados").jqGrid({
                url: '<%= Url.Action("ObtenerVersiones") %>',
                editurl: '<%= Url.Action("EditarVersion") %>',
                datatype: 'json',
                mtype: 'POST',
                colNames: ['CursoIdint', 'Nombre', 'Tipo', 'Activa', '', 'T', '', '', 'F', ''],
                colModel: [
                { name: 'CursoIdint', index: 'CursoIdint', editable: true, hidden: true },
                { name: 'Nombre', Nombre: 'Nombre', width: 20, align: 'center', sortable: true, searchoptions: { sopt: ['cn'] }, editable: true, editoptions: { size: '60', maxlength: '50' }, editrules: { required: true} },
                { name: 'TipoVersion', index: 'Tipo', width: 5, align: 'center', edittype: 'select', editable: true, editoptions: { value: { 1: 'Online', 2: 'Distancia', 3: 'Presencial'} }, editrules: { required: true }, searchoptions: { sopt: ['eq']} },
                {name: 'Activa', index: 'FechaBaja', edittype: 'checkbox', width: 5, align: 'center', editable: true, editoptions: { value: "True:False", defaultValue: "True" }, editrules: { required: false }, formatter: "checkbox", formatoptions: { disabled: true} },
                { name: 'TI', index: 'TI', width: 1, sortable: false, search: false },
                { name: 'TC', index: 'TC', width: 1, sortable: false, search: false },
                { name: 'TE', index: 'TE', width: 1, sortable: false, search: false },
                { name: 'FI', index: 'FI', width: 1, sortable: false, search: false },
                { name: 'FC', index: 'FC', width: 1, sortable: false, search: false },
                { name: 'FE', index: 'FE', width: 1, sortable: false, search: false }
                ],
                pager: jQuery('#paginador_hijos1_asignados'),
                rowNum: 10,
                rowList: [10, 25, 50, 100, 1000],
                sortname: 'FechaBaja',
                sortorder: 'asc',
                viewrecords: true,
                imgpath: '/Content/jqgrid/images',
                caption: 'Versiones del curso seleccionado',
                height: 231,
                width: 700,
                hiddengrid: true,
                multiselect: false,
                viewrecords: true,
                ondblClickRow: function (row_id, iRow, iCol, e) { jQuery('#grid_hijos1_asignados').editGridRow(row_id, editOptions); },
                gridComplete: insertarBotonesFirmas,
                loadError: function () { window.location = "/Home/ErrorEndRequest" }
            }).navGrid('#paginador_hijos1_asignados', { search: false, edit: true, add: true, del: true, refresh: false, searchtext: '' }, editOptions, addOptionsVersionManual, deleteOptions, searchOptions);
        })
    </script>

    <div id="div_hijos2" style="visibility:hidden">
    &nbsp;
    <table width="100%">
        <tr>
            <td>
                <table width="20">
                </table>
            </td>
            <td>
                <table id="grid_hijos2_asignados"></table>
                <div id="paginador_hijos2_asignados"></div>
            </td>
            <td>
                <table width="40">
                </table>
            </td>
            <td>
                <table id="grid_hijos2_noasignados"></table>
                <div id="paginador_hijos2_noasignados"></div>
            </td>
        </tr>
    </table>
    </div>
    <script type="text/javascript" language="javascript">
        var addOptionsPlanificacionManual = {
            caption: '',
            buttonicon: 'ui-icon-plus',
            position: 'first',
            closeAfterAdd: true,
            closeOnEscape: true,
            savekey: [true, 13],
            height: "auto",
            width: 500,
            beforeSubmit: function (postdata, formid) {
                if (obtenerCurso() == 0) {
                    return [false, 'Seleccione el curso al que desea asociar la planificación'];
                }
                else {
                    postdata.CursoIdint = obtenerCurso();
                    return [true];
                }
            },
            onInitializeForm: function () { $('#Fecha').datepicker({ showButtonPanel: true, changeMonth: true, changeYear: true }); }
        }

        function longitudPlanificacionDescripcion(value, colname) {
            var max = 500;
            var campo = 'descripción';
            if (value.length > max)
                return [false, 'INFORMACIÓN: El campo ' + campo + ' no debe superar los ' + max + ' caracteres'];
            else
                return [true, ''];
        }

        jQuery(document).ready(function () {
            jQuery("#grid_hijos2_asignados").jqGrid({
                url: '<%= Url.Action("ObtenerPlanificacionesAsignadas") %>',
                editurl: '<%= Url.Action("EditarPlanificacion") %>',
                datatype: 'json',
                mtype: 'POST',
                colNames: ['CursoIdint', 'Nombre', 'Fecha', 'Descripción'],
                colModel: [
                { name: 'CursoIdint', index: 'CursoIdint', editable: true, hidden: true },
                { name: 'Nombre', index: 'Nombre', width: 15, align: 'left', sortable: true, searchoptions: { sopt: ['cn'] }, editable: true, editoptions: { size: '60', maxlength: '100' }, editrules: { required: true} },
                { name: 'Fecha', index: 'Fecha', width: 15, align: 'center', sortable: true, searchoptions: { sopt: ['eq'] }, editable: true, editoptions: { size: "20", maxlength: "30" }, editrules: { required: true, date: true }, datefmt: 'dd/mm/yyyy' },
                { name: 'Descripcion', index: 'Descripcion', edittype: 'textarea', width: 40, align: 'left', sortable: false, searchoptions: { sopt: ['cn'] }, editable: true, editoptions: { rows: '7', cols: '60' }, editrules: { required: false, custom: true, custom_func: longitudPlanificacionDescripcion} }
                ],
                pager: jQuery('#paginador_hijos2_asignados'),
                rowNum: 10,
                rowList: [10, 25, 50, 100, 1000],
                sortname: 'Fecha',
                sortorder: 'desc',
                viewrecords: true,
                imgpath: '/Content/jqgrid/images',
                caption: 'Planificaciones del curso seleccionado',
                height: 231,
                width: 700,
                hiddengrid: true,
                multiselect: false,
                viewrecords: true,
                ondblClickRow: function (row_id, iRow, iCol, e) { jQuery('#grid_hijos2_asignados').editGridRow(row_id, editOptions); },
                loadError: function () { window.location = "/Home/ErrorEndRequest" }
            }).navGrid('#paginador_hijos2_asignados', { search: false, edit: true, add: true, del: true, refresh: false, searchtext: '' }, editOptions, addOptionsPlanificacionManual, deleteOptions, searchOptions);
        })
    </script>

    </div>
</asp:Content>


