﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder_Title" runat="server">
    Sistema para la Gestión de la Formación - Ediciones
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder_Main" runat="server">
    <div id="div_contenedor">

    <div id="div_padre">
    <table id="grid_padre"></table>
    <div id="paginador_padre"></div>
    </div>
    
    <script type="text/javascript" language="javascript">
        var varibleGlobal = this;
        varibleGlobal.edicion = 0;

        function almacenarEdicion(edicionActual) {
            varibleGlobal.edicion = edicionActual;
        }

        function obtenerEdicion() {
            return varibleGlobal["edicion"];
        }

        function almacenarSesion(sesionActual) {
            varibleGlobal.sesion = sesionActual;
        }

        function obtenerSesion() {
            return varibleGlobal["sesion"];
        }

        function padreSelectRow(rowid) {
            ocultarSubgrid(0);
            jQuery("#div_hijos2").hide("slow"); almacenarSesion(0);
            almacenarEdicion(rowid);
            refrescarGridsHijos();
        }

        function padreLoadComplete() {
            almacenarEdicion(0);
            almacenarSesion(0);
            refrescarGridsHijos();
        }

        function refrescarGridsHijos() {
            if ($('#div_hijos1').is(':visible')) {
                refrescarGridHijo1($('#grid_hijos1_asignados'));
                refrescarGridHijo1($('#grid_hijos1_noasignados'));
            }
            if ($('#div_hijos2').is(':visible')) {
                refrescarGridHijo2($('#grid_hijos2_asignados'));
            }
        }

        function refrescarGridHijo1(grid) {
            grid.setGridParam({ postData: { edicionActual: obtenerEdicion() }, datatype: 'json' }).trigger('reloadGrid');
        }

        function refrescarGridHijo2(grid) {
            grid.setGridParam({ postData: { sesionActual: obtenerSesion() }, datatype: 'json' }).trigger('reloadGrid');
        }

        function expandirHijo1() {
            if ($('#div_hijos1').is(':hidden')) {
                document.getElementById("div_hijos1").style.visibility = "visible";
                refrescarGridHijo1($('#grid_hijos1_asignados'));
                refrescarGridHijo1($('#grid_hijos1_noasignados'));
                jQuery("#grid_hijos1_asignados").setGridState('visible');
                jQuery("#grid_hijos1_noasignados").setGridState('visible');
                jQuery("#div_hijos1").show("slow");
                jQuery("#div_hijos2").hide("slow");
            } 
            else { 
                jQuery("#grid_hijos1_asignados").setGridState('hidden');
                jQuery("#grid_hijos1_noasignados").setGridState('hidden');
                jQuery("#div_hijos1").hide("slow");
            }
        }

        function expandirHijo2() {
            if ($('#div_hijos2').is(':hidden')) {
                document.getElementById("div_hijos2").style.visibility = "visible";
                refrescarGridHijo2($('#grid_hijos2_asignados'));
                jQuery("#grid_hijos2_asignados").setGridState('visible');
                jQuery("#grid_hijos2_noasignados").setGridState('visible');
                jQuery("#div_hijos2").show("slow");
                jQuery("#div_hijos1").hide("slow");
            }
            else {
                jQuery("#grid_hijos2_asignados").setGridState('hidden');
                jQuery("#grid_hijos2_noasignados").setGridState('hidden');
                jQuery("#div_hijos2").hide("slow");
            }
        }

        var addOptions = {
            width: 700,
            closeAfterAdd: true,
            closeOnEscape: true,
            savekey: [true, 13],
            height: "auto",
            beforeShowForm: function (form) {
                //$('#SesionesDias', form).show();
                $('#SesionesDias', form).removeAttr('disabled');
                $('#DuracionMinutos', form).removeAttr('disabled');
            },
            onInitializeForm: function () {
                $('#FechaInicio').datepicker({ showButtonPanel: true, changeMonth: true, changeYear: true });
                $('#FechaFin').datepicker({ showButtonPanel: true, changeMonth: true, changeYear: true });
            }
        }

        var editOptions = {
            width: 500,
            closeAfterEdit: true,
            closeOnEscape: true,
            savekey: [true, 13],
            height: "auto",
            beforeShowForm: function (form) {
                //$('#SesionesDias', form).hide();
                $('#SesionesDias', form).attr('disabled', 'disabled');
                $('#DuracionMinutos', form).attr('disabled', 'disabled');
            },
            onInitializeForm: function () {
                $('#FechaInicio').datepicker({ showButtonPanel: true, changeMonth: true, changeYear: true });
                $('#FechaFin').datepicker({ showButtonPanel: true, changeMonth: true, changeYear: true });
                $('#FInicio').datetimepicker($.timepicker.regional['es']);
                $('#FFin').datetimepicker($.timepicker.regional['es']);
            }
        }

        var deleteOptions = {
            width: 500,
            closeAfterDel: true,
            closeOnEscape: true,
            savekey: [true, 13],
            height: "auto"
        }

        var searchOptions = {
            closeOnEscape: true,
            closeAfterSearch: true,
            beforeShowSearch: function (form) { form.keydown(function (e) { if (e.which == 13) { $(".ui-search", form).click(); } }); },
            //onClose: function (form) { form.unbind('keydown'); },
            multipleSearch: false
        }

        eliminarFirmas = function (rowId) {
            if (confirm("¿Seguro que desea eliminar la hoja de firmas?")) {
                $.ajax({
                    type: 'POST',
                    url: '<%= Url.Action("FirmasEliminar") %>',
                    data: { edicionActual: rowId },
                    success: function (data, textStatus, XMLHttpRequest) {
                        jQuery("#grid_padre").trigger('reloadGrid');
                        alert('Hoja de firmas eliminada');
                    },
                    error: function (req, status, error) { alert('Error recuperando datos'); }
                });
            }
        };

        function insertarBotonesFirmas() {
            var grid = jQuery("#grid_padre");
            var ids = grid.jqGrid('getDataIDs');
            for (var i = 0; i < ids.length; i++) {
                var rowId = ids[i];
                
                var checkOut = "<div id='file-uploader" + rowId + "' title='Asociar hoja de firmas'></div>";
                grid.jqGrid('setRowData', rowId, { I: checkOut });
                
                if (grid.jqGrid('getCell', rowId, 'C') == "true") {
                    checkOut = "<img src='/Content/images/documento_ver.png' alt='Consultar hoja de firmas' onclick=\"window.open('Firmas/" + rowId + "');\" />";
                    grid.jqGrid('setRowData', rowId, { C: checkOut });
                }
                else {
                    grid.jqGrid('setCell', rowId, 'C', ' ');
                }

                if (grid.jqGrid('getCell', rowId, 'E') == "true") {
                    checkOut = "<img src='/Content/images/documento_eliminar.png' alt='Eliminar hoja de firmas' onclick=\"eliminarFirmas(" + rowId + ");\" />";
                    grid.jqGrid('setRowData', rowId, { E: checkOut });
                }
                else {
                    grid.jqGrid('setCell', rowId, 'E', ' ');
                }

                var uploader = new qq.FileUploader({
                    element: document.getElementById('file-uploader' + rowId),
                    action: '/MEdiciones/Upload/' + rowId,
                    onComplete: function (id, fileName, responseJSON) {
                        jQuery("#grid_padre").trigger('reloadGrid');
                        alert('Fichero almacenado');
                    }
                });
            }
        }

        jQuery(document).ready(function () {
            jQuery("#grid_padre").jqGrid({
                url: '<%= Url.Action("ObtenerEdiciones") %>',
                editurl: '<%= Url.Action("EditarEdicion") %>',
                datatype: 'json',
                mtype: 'POST',
                colNames: ['Curso', 'Version', 'Curso - Versión', 'Fecha Inicio', 'Fecha Fin', 'Sesiones', 'Duración', '', '', ''],
                colModel: [
                { name: 'Curso', index: 'Curso', editable: true, hidden: true, search: true, searchoptions: { sopt: ['cn']} },
                { name: 'Version', index: 'Version', editable: true, hidden: true, search: true, searchoptions: { sopt: ['cn']} },
                { name: 'CursoVersion', index: 'CursoVersion', edittype: 'select', width: 40, align: 'left', editable: true, editoptions: { dataUrl: '<%= Url.Action("ObtenerDesplegableVersiones") %>' }, editrules: { required: true }, sortable: false, searchoptions: { sopt: ['cn']} },
                { name: 'FechaInicio', index: 'FechaInicio', edittype: 'text', width: 10, align: 'center', editable: true, editrules: { required: true }, sortable: true, searchoptions: { sopt: ['eq']} },
                { name: 'FechaFin', index: 'FechaFin', edittype: 'text', width: 10, align: 'center', editable: true, editrules: { required: true }, sortable: true, searchoptions: { sopt: ['eq']} },
                { name: 'SesionesDias', index: 'SesionesDias', edittype: 'text', width: 10, align: 'center', editable: true, editoptions: { size: "7", maxlength: "2" }, editrules: { required: true, number: true, minValue: 1 }, sortable: true, searchoptions: { sopt: ['eq']} },
                { name: 'DuracionMinutos', index: 'DuracionMinutos', edittype: 'text', width: 10, align: 'center', editable: true, editoptions: { size: "7", maxlength: "4" }, editrules: { required: true, number: true, minValue: 1 }, sortable: true, searchoptions: { sopt: ['eq'] }, formoptions: { elmsuffix: ' horas' }, formatter: formatoMinutosON, unformat: formatoMinutosOFF },
                { name: 'I', index: 'I', width: 2, sortable: false, search: false },
                { name: 'C', index: 'C', width: 2, sortable: false, search: false },
                { name: 'E', index: 'E', width: 2, sortable: false, search: false }
                ],
                pager: jQuery('#paginador_padre'),
                rowNum: 10,
                rowList: [10, 25, 50, 100, 1000],
                sortname: 'FechaInicio',
                sortorder: 'desc',
                viewrecords: true,
                imgpath: '/Content/jqgrid/images',
                caption: 'Listado de Ediciones',
                //height: '100%',
                height: '231',
                autowidth: true,
                subGrid: true,
                subGridRowExpanded: cargarSubgrid,
                subGridRowColapsed: contraerSubgrid,
                //ondblClickRow: function (row_id, iRow, iCol, e) { jQuery('#grid_padre').editGridRow(row_id, editOptions); },
                onSelectRow: padreSelectRow,
                loadComplete: padreLoadComplete,
                gridComplete: insertarBotonesFirmas,
                loadError: function () { window.location = "/Home/ErrorEndRequest" }
            }).navGrid('#paginador_padre', { search: true, edit: false, add: true, del: true, refresh: true, searchtext: '' }, editOptions, addOptions, deleteOptions, searchOptions);
            jQuery("#grid_padre").jqGrid('navButtonAdd', '#paginador_padre', { caption: "Convocatoria", onClickButton: expandirHijo1 });
            jQuery("#grid_padre").jqGrid('navButtonAdd', '#paginador_padre', { caption: "Control de Asistencia", onClickButton: expandirHijo2 });
            jQuery("#div_hijos1").hide();
            jQuery("#div_hijos2").hide();
        })

        function subpadreSelectRow(rowid) {
            jQuery("#div_hijos1").hide("slow");
            almacenarSesion(rowid);
            refrescarGridsHijos();
        }

        function ocultarSubgrid(row_id) {
            var grid = jQuery("#grid_padre");
            var ids = grid.jqGrid('getDataIDs');
            for (var i = 0; i < ids.length; i++) {
                var rowId = ids[i];
                if (rowId != row_id) {
                    grid.collapseSubGridRow(rowId);
                }
            }
        }

        function cargarSubgrid(subgrid_id, row_id) {
            ocultarSubgrid(row_id);
            jQuery("#div_hijos1").hide("slow");
            jQuery("#div_hijos2").hide("slow"); almacenarSesion(0);

            var subgrid_tabla_id;
            subgrid_tabla_id = subgrid_id + "_sub";
            jQuery("#" + subgrid_id).html("<table id='" + subgrid_tabla_id + "'></table>");

            jQuery("#" + subgrid_tabla_id).jqGrid({
                url: '<%= Url.Action("ObtenerSesiones") %>',
                editurl: '<%= Url.Action("EditarSesion") %>',
                datatype: "json",
                mtype: 'POST',
                colNames: ['#', 'Fecha Inicio', 'Fecha Fin', 'Lugar', 'Duración'],
                colModel: [
                { name: 'Numero', index: 'Numero', width: 5, align: 'center', editable: false },
                { name: 'FInicio', index: 'FechaInicio', width: 20, align: 'center', editable: true, editoptions: { size: '51' }, editrules: { required: true }, formoptions: { rowpos: 2} }, //key: true
                { name: 'FFin', index: 'FechaFin', width: 20, align: 'center', editable: true, editoptions: { size: '51' }, editrules: { required: true }, formoptions: { rowpos: 3} },
                { name: 'Ubicacion', index: 'Ubicacion', width: 80, align: 'left', editable: true, editoptions: { size: '51', maxlength: '300' }, editrules: { required: true }, formoptions: { rowpos: 1} },
                { name: 'DuracionMinutos', index: 'DuracionMinutos', width: 20, align: 'center', editable: false, formatter: formatoMinutosON, unformat: formatoMinutosOFF }
                ],
                height: '100%',
                autowidth: true,
                rowNum: 200,
                imgpath: '/Content/jqgrid/images',
                caption: 'Sesiones Formativas',
                sortname: 'Numero',
                sortorder: "asc",
                postData: { edicionActual: row_id },
                ondblClickRow: function (row_id, iRow, iCol, e) { jQuery("#" + subgrid_tabla_id).editGridRow(row_id, editOptions); },
                onSelectRow: subpadreSelectRow,
                loadError: function () { window.location = "/Home/ErrorEndRequest" }
            });
        }

        function contraerSubgrid(subgrid_id, row_id) {
            jQuery("#div_hijos1").hide("slow");
            jQuery("#div_hijos2").hide("slow"); almacenarSesion(0);
        }
    </script> 

    <div id="div_hijos1" style="visibility:hidden">
    &nbsp;
    <table width="100%">
        <tr>
            <td>
                <table width="20">
                </table>
            </td>
            <td>
                <table id="grid_hijos1_asignados"></table>
                <div id="paginador_hijos1_asignados"></div>
            </td>
            <td>
                <table width="40">
                </table>
            </td>
            <td>
                <table id="grid_hijos1_noasignados"></table>
                <div id="paginador_hijos1_noasignados"></div>
            </td>
        </tr>
    </table>
    </div>
    <script type="text/javascript" language="javascript">
        desconvocarEmpleado = function (rowId) {
            $('#desconvocar' + rowId).hide("slow");
            $.ajax({
                type: 'POST',
                url: '<%= Url.Action("DesconvocarEmpleado") %>',
                data: { empleadoIdint: rowId, edicionIdint: obtenerEdicion() },
                success: function (data, textStatus, XMLHttpRequest) {
                    $('#grid_hijos1_asignados').trigger('reloadGrid');
                    $('#grid_hijos1_noasignados').trigger('reloadGrid');
                },
                error: function (req, status, error) { alert('Error recuperando datos'); }
            });
        };

        function insertarBotonDesconvocarEmpleado() {
            var grid = jQuery("#grid_hijos1_asignados");
            var ids = grid.jqGrid('getDataIDs');
            for (var i = 0; i < ids.length; i++) {
                var rowId = ids[i];
                var checkOut = "<img id='desconvocar" + rowId + "' src='/Content/images/flecha_derecha.png' style='height:20px;width:20px;' onclick=\"desconvocarEmpleado(" + rowId + ");\" />";
                grid.jqGrid('setRowData', rowId, { action: checkOut });
            }
        }

        function completarParametrosEdicion() {
            return { edicionActual: obtenerEdicion() };
        }

        function longitudConvocatoriaObservacion(value, colname) {
            var max = 300;
            var campo = 'observación';
            if (value.length > max)
                return [false, 'INFORMACIÓN: El campo ' + campo + ' no debe superar los ' + max + ' caracteres'];
            else
                return [true, ''];
        }

        jQuery(document).ready(function () {
            jQuery("#grid_hijos1_asignados").jqGrid({
                caption: 'Empleados convocados a la edición seleccionada',
                url: '<%= Url.Action("ObtenerEmpleadosConvocados") %>',
                editurl: '<%= Url.Action("EditarConvocatoria") %>',
                datatype: 'json',
                mtype: 'POST',
                colNames: ['edicionActual', 'Apellidos', 'Nombre', 'Empleado', 'Ocupación', 'Asistencia', 'Completado', 'Observaciones', 'DeBaja', ''],
                colModel: [
                { name: 'edicionActual', index: 'edicionActual', editable: true, hidden: true },
                { name: 'Apellidos', index: 'Apellidos', width: 0, align: 'left', hidden: true, sortable: true, searchoptions: { sopt: ['cn'], searchhidden: true} },
                { name: 'Nombre', index: 'Nombre', width: 0, align: 'left', hidden: true, sortable: true, searchoptions: { sopt: ['cn'], searchhidden: true} },
                { name: 'Empleado', index: 'Empleado', edittype: 'text', width: 30, align: 'left', search: false, editable: false, editoptions: { size: "20", maxlength: "30" }, editrules: { edithidden: true, required: true }, searchoptions: { sopt: ['cn']} },
                { name: 'Ocupacion', index: 'Ocupacion', width: 10, align: 'center', sortable: true, searchoptions: { sopt: ['cn']} },
                { name: 'Asistencia', index: 'Asistencia', width: 10, align: 'center', sortable: true, searchoptions: { sopt: ['cn'] }, formatter: formatoPorcentajeON },
                { name: 'Completado', index: 'Completado', width: 10, align: 'center', sortable: true, editable: true, edittype: 'checkbox', editoptions: { value: 'Si:No' }, formatter: 'text', formatoptions: { disabled: false} },
                { name: 'Observaciones', index: 'Observaciones', width: 0, align: 'center', sortable: true, editable: true, hidden: true, edittype: 'textarea', editoptions: { rows: '5', cols: '60' }, editrules: { edithidden: true, custom: true, custom_func: longitudConvocatoriaObservacion} },
                { name: 'DeBaja', index: 'DeBaja', edittype: 'text', hidden: true, editable: false, editrules: { edithidden: true, required: true, date: true} },
                { name: 'action', index: 'action', width: 3, align: 'center', sortable: false, search: false}
                ],
                pager: jQuery('#paginador_hijos1_asignados'),
                rowNum: 10,
                rowList: [10, 25, 50, 100, 1000],
                sortname: 'Empleado',
                sortorder: 'asc',
                viewrecords: true,
                imgpath: '/Content/jqgrid/images',
                height: 231,
                width: 550,
                hiddengrid: true,
                multiselect: false,
                viewrecords: false,
                cellEdit: true,
                cellurl: '<%= Url.Action("EditarConvocatoria") %>',
                afterSaveCell: function (rowid, cellname, value, iRow, iCol) { refrescarGridHijo1($('#grid_hijos1_asignados')); },
                afterInsertRow: function (rowid, rowdata) { if (rowdata.DeBaja == 'Si') { $(this).jqGrid('setRowData', rowid, false, { color: 'Tomato' }); } },
                ondblClickRow: function (row_id, iRow, iCol, e) { jQuery('#grid_hijos1_asignados').editGridRow(row_id, editOptions); },
                beforeSubmitCell: completarParametrosEdicion,
                gridComplete: insertarBotonDesconvocarEmpleado,
                loadError: function () { window.location = "/Home/ErrorEndRequest" }
            }).navGrid('#paginador_hijos1_asignados', { search: false, edit: true, add: false, del: false, refresh: true, searchtext: '' }, editOptions, addOptions, deleteOptions, searchOptions);
        })
    </script>

    <script type="text/javascript" language="javascript">
        convocarEmpleado = function (rowId) {
            $('#convocar' + rowId).hide("slow");
            $.ajax({
                type: 'POST',
                url: '<%= Url.Action("ConvocarEmpleado") %>',
                data: { empleadoIdint: rowId, edicionIdint: obtenerEdicion() },
                success: function (response) {
                    $('#grid_hijos1_asignados').trigger('reloadGrid');
                    $('#grid_hijos1_noasignados').trigger('reloadGrid');
                },
                error: function (req, status, error) { alert("Error recuperando datos"); }
            });
        };

        function insertarBotonConvocarEmpleado() {
            var grid = jQuery("#grid_hijos1_noasignados");
            var ids = grid.jqGrid('getDataIDs');
            for (var i = 0; i < ids.length; i++) {
                var rowId = ids[i];
                var checkOut = "<img id='convocar" + rowId +"' src='/Content/images/flecha_izquierda.png' style='height:20px;width:20px;' onclick=\"convocarEmpleado(" + rowId + ");\" />";
                grid.jqGrid('setRowData', rowId, { action: checkOut });
            }
        }

        jQuery(document).ready(function () {
            jQuery("#grid_hijos1_noasignados").jqGrid({
                caption: 'Empleados NO convocados a la edición seleccionada',
                url: '<%= Url.Action("ObtenerEmpleadosNoConvocados") %>',
                datatype: 'json',
                mtype: 'POST',
                colNames: ['', 'Apellidos', 'Nombre', 'Empleado', 'Ocupación', 'Asignación', 'DeBaja'],
                colModel: [
                { name: 'action', index: 'action', width: 3, align: 'center', sortable: false, search: false },
                { name: 'Apellidos', index: 'Apellidos', width: 0, align: 'left', hidden: true, sortable: true, searchoptions: { sopt: ['cn'], searchhidden: true} },
                { name: 'Nombre', index: 'Nombre', width: 0, align: 'left', hidden: true, sortable: true, searchoptions: { sopt: ['cn'], searchhidden: true} },
                { name: 'Empleado', index: 'Empleado', edittype: 'text', width: 25, align: 'left', search: false, editable: false, editoptions: { size: "20", maxlength: "30" }, editrules: { edithidden: true, required: true }, searchoptions: { sopt: ['cn']} },
                { name: 'Ocupacion', index: 'Ocupacion', width: 8, align: 'center', sortable: false, search: false },
                { name: 'Asignacion', index: 'Asignacion', width: 8, align: 'center', sortable: false, search: false },
                { name: 'DeBaja', index: 'DeBaja', edittype: 'text', hidden: true, editable: false, editrules: { edithidden: true, required: true, date: true} }
                ],
                pager: jQuery('#paginador_hijos1_noasignados'),
                rowNum: 10,
                rowList: [10, 25, 50, 100, 1000],
                sortname: 'Empleado',
                sortorder: 'asc',
                viewrecords: true,
                imgpath: '/Content/jqgrid/images',
                height: 231,
                width: 450,
                hiddengrid: true,
                multiselect: false,
                viewrecords: false,
                afterInsertRow: function (rowid, rowdata) { if (rowdata.DeBaja == 'Si') { $(this).jqGrid('setRowData', rowid, false, { color: 'Tomato' }); } },
                gridComplete: insertarBotonConvocarEmpleado,
                loadError: function () { window.location = "/Home/ErrorEndRequest" }
            }).navGrid('#paginador_hijos1_noasignados', { search: true, edit: false, add: false, del: false, refresh: true, searchtext: '' }, editOptions, addOptions, deleteOptions, searchOptions);
        })
    </script>

    <div id="div_hijos2" style="visibility:hidden">
    &nbsp;
    <table width="100%">
        <tr>
            <td>
                <table width="20">
                </table>
            </td>
            <td>
                <table id="grid_hijos2_asignados"></table>
                <div id="paginador_hijos2_asignados"></div>
            </td>
            <td>
                <table width="40">
                </table>
            </td>
            <td>
                <table id="grid_hijos2_noasignados"></table>
                <div id="paginador_hijos2_noasignados"></div>
            </td>
        </tr>
    </table>
    </div>
    <script type="text/javascript" language="javascript">
        function completarParametrosSesion() {
            return { sesionActual: obtenerSesion() };
        }

        jQuery(document).ready(function () {
            jQuery("#grid_hijos2_asignados").jqGrid({
                caption: 'Control de asistencia a la edición seleccionada',
                url: '<%= Url.Action("ObtenerAsistencias") %>',
                datatype: 'json',
                mtype: 'POST',
                colNames: ['Apellidos', 'Nombre', 'Empleado', 'Ocupación', 'Asiste', 'DeBaja'],
                colModel: [
                { name: 'Apellidos', index: 'Apellidos', width: 0, align: 'left', hidden: true, sortable: true, searchoptions: { sopt: ['cn'], searchhidden: true} },
                { name: 'Nombre', index: 'Nombre', width: 0, align: 'left', hidden: true, sortable: true, searchoptions: { sopt: ['cn'], searchhidden: true} },
                { name: 'Empleado', index: 'Empleado', edittype: 'text', width: 25, align: 'left', search: false, editable: false, editoptions: { size: "20", maxlength: "30" }, editrules: { edithidden: true, required: true }, searchoptions: { sopt: ['cn']} },
                { name: 'Ocupacion', index: 'Ocupacion', width: 10, align: 'center', sortable: true },
                { name: 'Asiste', index: 'Asiste', width: 10, align: 'center', sortable: true, editable: true, edittype: 'checkbox', editoptions: { value: 'Si:No' }, formatter: 'text', formatoptions: { disabled: false} },
                { name: 'DeBaja', index: 'DeBaja', edittype: 'text', hidden: true, editable: false, editrules: { edithidden: true, required: true, date: true} }
                ],
                pager: jQuery('#paginador_hijos2_asignados'),
                rowNum: 10,
                rowList: [10, 25, 50, 100, 1000],
                sortname: 'Empleado',
                sortorder: 'asc',
                viewrecords: true,
                imgpath: '/Content/jqgrid/images',
                height: 231,
                width: 700,
                hiddengrid: true,
                multiselect: false,
                viewrecords: true,
                cellEdit: true,
                cellurl: '<%= Url.Action("AsignarAsistencia") %>',
                beforeSubmitCell: completarParametrosSesion,
                afterInsertRow: function (rowid, rowdata) { if (rowdata.DeBaja == 'Si') { $(this).jqGrid('setRowData', rowid, false, { color: 'Tomato' }); } },
                loadError: function () { window.location = "/Home/ErrorEndRequest" }
            }).navGrid('#paginador_hijos2_asignados', { search: false, edit: false, add: false, del: false, refresh: true, searchtext: '' }, editOptions, {}, deleteOptions, searchOptions);
        })
    </script>

    </div>
</asp:Content>