﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage<dynamic>" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder_Title" runat="server">
    Sistema para la Gestión de la Formación - Empleados
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder_Main" runat="server">
    
    <div id="div_padre">
    <table id="grid_padre"></table>
    <div id="paginador_padre"></div>
    </div>
    <script type="text/javascript" language="javascript">
        var varibleGlobal = this;
        varibleGlobal.empleado = 0;

        function almacenarEmpleado(empleadoActual) {
            varibleGlobal.empleado = empleadoActual;
        }

        function obtenerEmpleado() {
            return varibleGlobal["empleado"];
        }

        function padreSelectRow(rowid) {
            almacenarEmpleado(rowid);
            refrescarGridsHijos();
        }

        function padreLoadComplete() {
            almacenarEmpleado(0);
            refrescarGridsHijos();
        }

        function refrescarGridsHijos() {
            if ($('#div_hijos1').is(':visible')) {
                refrescarGridHijo($('#grid_hijos1_asignados'));
                refrescarGridHijo($('#grid_hijos1_noasignados'));
            }
        }

        function refrescarGridHijo(grid) {
            grid.setGridParam({ postData: { empleadoActual: obtenerEmpleado() }, datatype: 'json' }).trigger('reloadGrid');
        }

        function expandirHijo1() {
            if ($('#div_hijos1').is(':hidden')) {
                document.getElementById("div_hijos1").style.visibility = "visible";
                refrescarGridHijo($('#grid_hijos1_asignados'));
                refrescarGridHijo($('#grid_hijos1_noasignados'));
                jQuery("#grid_hijos1_asignados").setGridState('visible');
                jQuery("#grid_hijos1_noasignados").setGridState('visible');
                jQuery("#div_hijos1").show("slow");
                jQuery("#div_hijos2").hide("slow");
            }
            else {
                jQuery("#grid_hijos1_asignados").setGridState('hidden');
                jQuery("#grid_hijos1_noasignados").setGridState('hidden');
                jQuery("#div_hijos1").hide("slow");
            }
        }
        
        var addOptions = {
            width: 500,
            closeAfterAdd: true,
            closeOnEscape: true,
            savekey: [true, 13],
            height: "auto",
            onInitializeForm: function () {
                $('#FechaIngreso').datepicker({ showButtonPanel: true, changeMonth: true, changeYear: true });
                $('#FechaBaja').datepicker({ showButtonPanel: true, changeMonth: true, changeYear: true });
            }
        }

        var editOptions = {
            width: 500,
            closeAfterEdit: true,
            closeOnEscape: true,
            savekey: [true, 13],
            height: "auto"
        }

        var editFechaIngreso = {
            width: 500,
            closeAfterEdit: true,
            closeOnEscape: true,
            savekey: [true, 13],
            height: "auto",
            onInitializeForm: function () {
                $('#FechaIngreso').datepicker({ showButtonPanel: true, changeMonth: true, changeYear: true });
                $('#FechaBaja').datepicker({ showButtonPanel: true, changeMonth: true, changeYear: true });
            }
        }

        var deleteOptions = {
            width: 500,
            closeAfterDel: true,
            closeOnEscape: true,
            savekey: [true, 13],
            height: "auto"
        }

        var searchOptions = {
            closeOnEscape: true,
            closeAfterSearch: true,
            beforeShowSearch: function (form) { form.keydown(function (e) { if (e.which == 13) { $(".ui-search", form).click(); } }); },
            //onClose: function (form) { form.unbind('keydown'); },
            multipleSearch: false
        }

        jQuery(document).ready(function () {
            jQuery("#grid_padre").jqGrid({
                caption: 'Listado de Empleados',
                url: '<%= Url.Action("ObtenerDatosGrid") %>',
                editurl: '<%= Url.Action("EditarDatosGrid") %>',
                datatype: 'json',
                mtype: 'POST',
                colNames: ['Idint', 'DNI', 'Nombre', 'Apellidos', 'Empleado', 'Mail', 'F. Ingreso', 'F. Baja', 'Ocupación', 'F. Ocupación', 'DeBaja'],
                colModel: [
                { name: 'Idint', index: 'Idint', edittype: 'text', width: 10, align: 'center', editable: false, hidden: true, searchoptions: { sopt: ['eq']} },
                { name: 'DNI', index: 'DNI', edittype: 'text', width: 10, align: 'center', editable: true, hidedlg: true, editoptions: { size: "20", maxlength: "30" }, editrules: { required: true }, searchoptions: { sopt: ['cn']} },
                { name: 'Nombre', index: 'Nombre', edittype: 'text', width: 20, align: 'center', hidden: true, editable: true, editoptions: { size: "20", maxlength: "30" }, editrules: { edithidden: true, required: true }, search: true, searchoptions: { sopt: ['cn'], searchhidden: true} },
                { name: 'Apellidos', index: 'Apellidos', edittype: 'text', width: 20, align: 'center', hidden: true, editable: true, editoptions: { size: "20", maxlength: "30" }, editrules: { edithidden: true, required: true }, search: true, searchoptions: { sopt: ['cn'], searchhidden: true} },
                { name: 'Empleado', index: 'Empleado', edittype: 'text', width: 20, align: 'center', search: false, editable: false, editoptions: { size: "20", maxlength: "30" }, editrules: { edithidden: true, required: true }, searchoptions: { sopt: ['cn']} },
                { name: 'Mail', index: 'Mail', edittype: 'text', width: 20, align: 'center', editable: true, editoptions: { size: "20", maxlength: "30" }, editrules: { edithidden: true, required: true, email: true }, search: false },
                { name: 'FechaIngreso', index: 'FechaIngreso', edittype: 'text', width: 10, align: 'center', editable: true, editoptions: { size: "20", maxlength: "30" }, editrules: { edithidden: true, required: true, date: true }, datefmt: 'dd/mm/yyyy', search: false },
                { name: 'FechaBaja', index: 'FechaBaja', edittype: 'text', width: 10, align: 'center', editable: true, editoptions: { size: "20", maxlength: "30" }, editrules: { edithidden: true, required: false, date: true }, datefmt: 'dd/mm/yyyy', search: false },
                { name: 'Ocupacion', index: 'Ocupacion', edittype: 'text', width: 10, align: 'center', sortable: false, editable: false, editoptions: { size: "20", maxlength: "30" }, editrules: { edithidden: true, required: true }, search: false },
                { name: 'FechaOcupacion', index: 'FechaOcupacion', edittype: 'text', width: 10, align: 'center', sortable: false, editable: false, editoptions: { size: "20", maxlength: "30" }, editrules: { edithidden: true, required: true, date: true }, datefmt: 'dd/mm/yyyy', search: false },
                { name: 'DeBaja', index: 'DeBaja', edittype: 'text', hidden: true, editable: false, editrules: { edithidden: true, required: true, date: true} }
                ],
                pager: jQuery('#paginador_padre'),
                rowNum: 10,
                rowList: [10, 25, 50, 100, 1000],
                sortname: 'Empleado',
                sortorder: 'asc',
                viewrecords: true,
                //scrollOffset: 0,
                imgpath: '/Content/jqgrid/images',
                height: '231',
                autowidth: true,
                afterInsertRow: function (rowid, rowdata) { if (rowdata.DeBaja == 'Si') { $(this).jqGrid('setRowData', rowid, false, { color: 'Tomato' }); } },
                ondblClickRow: function (row_id, iRow, iCol, e) { jQuery('#grid_padre').editGridRow(row_id, editFechaIngreso); },
                onSelectRow: padreSelectRow,
                loadComplete: padreLoadComplete,
                loadError: function () { window.location = "/Home/ErrorEndRequest" }
            }).navGrid('#paginador_padre', { search: true, edit: true, add: true, del: true, refresh: true, searchtext: '' }, editFechaIngreso, addOptions, deleteOptions, searchOptions);
            jQuery("#grid_padre").jqGrid('navButtonAdd', '#paginador_padre', { caption: "Cursos", onClickButton: expandirHijo1 });
            jQuery("#div_hijos1").hide();
        })

    </script>

    <div id="div_hijos1" style="visibility:hidden">
    &nbsp;
    <table width="100%">
        <tr>
            <td>
                <table width="20">
                </table>
            </td>
            <td>
                <table id="grid_hijos1_asignados"></table>
                <div id="paginador_hijos1_asignados"></div>
            </td>
            <td>
                <table width="40">
                </table>
            </td>
            <td>
                <table id="grid_hijos1_noasignados"></table>
                <div id="paginador_hijos1_noasignados"></div>
            </td>
        </tr>
    </table>
    </div>
    <script type="text/javascript" language="javascript">
        desasignarCurso = function (rowId) {
            $('#desasignar' + rowId).hide("slow");
            $.ajax({
                type: 'POST',
                url: '<%= Url.Action("DesasignarCurso") %>',
                data: { cursoIdint: rowId, empleadoIdint: obtenerEmpleado() },
                success: function (data, textStatus, XMLHttpRequest) {
                    $('#grid_hijos1_asignados').trigger('reloadGrid');
                    $('#grid_hijos1_noasignados').trigger('reloadGrid');
                },
                error: function (req, status, error) { alert('Error recuperando datos'); }
            });
        };

        function insertarBotonDesasignarCurso() {
            var grid = jQuery("#grid_hijos1_asignados");
            var ids = grid.jqGrid('getDataIDs');
            for (var i = 0; i < ids.length; i++) {
                var rowId = ids[i];
                var checkOut = "<img id='desasignar" + rowId + "' src='/Content/images/flecha_derecha.png' style='height:20px;width:20px;' onclick=\"desasignarCurso(" + rowId + ");\" />";
                grid.jqGrid('setRowData', rowId, { action: checkOut });
            }
        }

        function completarParametros(rowid, celname, value, iRow, iCol) {
            return { empleadoActual: obtenerEmpleado() };
        }

        var editAsignacion = {
            width: 500,
            closeAfterEdit: true,
            closeOnEscape: true,
            savekey: [true, 13],
            height: "auto",
            onInitializeForm: function () {
                $('#FechaAsignacion').datepicker({ showButtonPanel: true, changeMonth: true, changeYear: true });
            }
        }

        jQuery(document).ready(function () {
            jQuery("#grid_hijos1_asignados").jqGrid({
                url: '<%= Url.Action("ObtenerCursosAsignados") %>',
                editurl: '<%= Url.Action("EditarAsignacion") %>',
                datatype: 'json',
                mtype: 'POST',
                colNames: ['EmpleadoIdint', 'Curso', 'Tipo', 'Exento', 'F.Asignación', ''],
                colModel: [
                { name: 'EmpleadoIdint', index: 'EmpleadoIdint', editable: true, hidden: true },
                { name: 'Nombre', index: 'Nombre', width: 25, align: 'center', sortable: true, searchoptions: { sopt: ['cn']} },
                { name: 'Tipo', index: 'Tipo', width: 8, align: 'center', sortable: true, searchoptions: { sopt: ['eq']} },
                { name: 'Exento', index: 'Exento', edittype: 'checkbox', width: 8, align: 'center', editable: true, editoptions: { value: "True:False" }, editrules: { required: false }, formatter: "checkbox", formatoptions: { disabled: true }, search: false },
                { name: 'FechaAsignacion', index: 'FechaAsignacion', width: 10, align: 'center', sortable: true, editable: true, editoptions: { size: "20", maxlength: "30" }, editrules: { required: true, date: true }, datefmt: 'dd/mm/yyyy', search: false },
                { name: 'action', index: 'action', width: 4, align: 'center', sortable: false, search: false}],
                pager: jQuery('#paginador_hijos1_asignados'),
                rowNum: 10,
                rowList: [10, 25, 50, 100, 1000],
                sortname: 'Nombre',
                sortorder: 'asc',
                viewrecords: true,
                imgpath: '/Content/jqgrid/images',
                caption: 'Cursos asignados al empleado seleccionado',
                height: 231,
                width: 500,
                hiddengrid: true,
                multiselect: false,
                viewrecords: false,
                //beforeSubmitCell: completarParametros,
                ondblClickRow: function (row_id, iRow, iCol, e) { jQuery('#grid_hijos1_asignados').editGridRow(row_id, editAsignacion); },
                gridComplete: insertarBotonDesasignarCurso,
                loadError: function () { window.location = "/Home/ErrorEndRequest" }
            }).navGrid('#paginador_hijos1_asignados', { search: true, edit: true, add: false, del: false, refresh: true, searchtext: '' }, editAsignacion, addOptions, deleteOptions, searchOptions);
        })
    </script>

    <script type="text/javascript" language="javascript">
        asignarCurso = function (rowId) {
            $('#asignar' + rowId).hide("slow");
            $.ajax({
                type: 'POST',
                url: '<%= Url.Action("AsignarCurso") %>',
                data: { cursoIdint: rowId, empleadoIdint: obtenerEmpleado() },
                success: function (response) {
                    $('#grid_hijos1_asignados').trigger('reloadGrid');
                    $('#grid_hijos1_noasignados').trigger('reloadGrid');
                },
                error: function (req, status, error) { alert("Error recuperando datos"); }
            });
        };

        function insertarBotonAsignarCurso() {
            var grid = jQuery("#grid_hijos1_noasignados");
            var ids = grid.jqGrid('getDataIDs');
            for (var i = 0; i < ids.length; i++) {
                var rowId = ids[i];
                var checkOut = "<img id='asignar" + rowId + "' src='/Content/images/flecha_izquierda.png' style='height:20px;width:20px;' onclick=\"asignarCurso(" + rowId + ");\" />";
                grid.jqGrid('setRowData', rowId, { action: checkOut });
            }
        }

        jQuery(document).ready(function () {
            jQuery("#grid_hijos1_noasignados").jqGrid({
                url: '<%= Url.Action("ObtenerCursosNoAsignados") %>',
                datatype: 'json',
                mtype: 'POST',
                colNames: ['', 'Curso', 'Tipo'],
                colModel: [
                { name: 'action', index: 'action', width: 2, align: 'center', sortable: false, search: false },
                { name: 'Nombre', index: 'Nombre', width: 16, align: 'center', sortable: true, searchoptions: { sopt: ['cn']} },
                { name: 'Tipo', index: 'Tipo', width: 7, align: 'center', sortable: true, searchoptions: { sopt: ['eq']}}],
                pager: jQuery('#paginador_hijos1_noasignados'),
                rowNum: 10,
                rowList: [10, 25, 50, 100, 1000],
                sortname: 'Nombre',
                sortorder: 'asc',
                viewrecords: true,
                imgpath: '/Content/jqgrid/images',
                caption: 'Cursos NO asignados al empleado seleccionado',
                height: 231,
                width: 450,
                hiddengrid: true,
                multiselect: false,
                viewrecords: false,
                gridComplete: insertarBotonAsignarCurso,
                loadError: function () { window.location = "/Home/ErrorEndRequest" }
            }).navGrid('#paginador_hijos1_noasignados', { search: true, edit: false, add: false, del: false, refresh: true, searchtext: '' }, editOptions, addOptions, deleteOptions, searchOptions);
        })
    </script>

</asp:Content>
