﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NHibernate_SGF.Entities
{
    /// <summary>
    /// Empleado
    /// </summary>
    public class Empleado
    {
        private int intIdint;
        private string strDNI;
        private string strNombre;
        private string strApellidos;
        private string strMail;
        private DateTime datFechaIngreso;
        private DateTime datFechaBaja;
        private DateTime datFechaModi;
        private IList<EmpleadoColectivo> lstEmpleadoColectivo;
        private IList<EmpleadoCurso> lstEmpleadoCurso;
        private IList<Convocatoria> lstConvocatorias;
        private IList<Asistencia> lstAsistencias;

        /// <summary>
        /// Constructor
        /// </summary>
        public Empleado()
        {
            this.EmpleadosColectivos = new List<EmpleadoColectivo>();
            this.EmpleadosCursos = new List<EmpleadoCurso>();
            this.Convocatorias = new List<Convocatoria>();
            this.Asistencias = new List<Asistencia>();
        }

        /// <summary>
        /// Identificador
        /// </summary>
        public virtual int Idint
        {
            get { return intIdint; }
            set { intIdint = value; }
        }

        /// <summary>
        /// DNI
        /// </summary>
        public virtual string DNI
        {
            get { return strDNI; }
            set { strDNI = value; }
        }

        /// <summary>
        /// Nombre
        /// </summary>
        public virtual string Nombre
        {
            get { return strNombre; }
            set { strNombre = value; }
        }

        /// <summary>
        /// Apellidos
        /// </summary>
        public virtual string Apellidos
        {
            get { return strApellidos; }
            set { strApellidos = value; }
        }

        /// <summary>
        /// Correo electrónico
        /// </summary>
        public virtual string Mail
        {
            get { return strMail; }
            set { strMail = value; }
        }

        /// <summary>
        /// Fecha de ingreso en la empresa
        /// </summary>
        public virtual DateTime FechaIngreso
        {
            get { return datFechaIngreso; }
            set { datFechaIngreso = value; }
        }

        /// <summary>
        /// Fecha de baja en la empresa
        /// </summary>
        public virtual DateTime FechaBaja
        {
            get { return datFechaBaja; }
            set { datFechaBaja = value; }
        }

        /// <summary>
        /// Fecha de modificación
        /// </summary>
        public virtual DateTime FechaModi
        {
            get { return datFechaModi; }
            set { datFechaModi = value; }
        }

        /// <summary>
        /// Lista de vinculación entre el empleado y sus colectivos
        /// </summary>
        public virtual IList<EmpleadoColectivo> EmpleadosColectivos
        {
            get { return lstEmpleadoColectivo; }
            set { lstEmpleadoColectivo = value; }
        }

        /// <summary>
        /// Lista de vinculación entre el empleado y sus cursos
        /// </summary>
        public virtual IList<EmpleadoCurso> EmpleadosCursos
        {
            get { return lstEmpleadoCurso; }
            set { lstEmpleadoCurso = value; }
        }

        /// <summary>
        /// Lista de convocatorias del empleado
        /// </summary>
        public virtual IList<Convocatoria> Convocatorias
        {
            get { return lstConvocatorias; }
            set { lstConvocatorias = value; }
        }

        /// <summary>
        /// Lista de asistencias del empleado
        /// </summary>
        public virtual IList<Asistencia> Asistencias
        {
            get { return lstAsistencias; }
            set { lstAsistencias = value; }
        }

    }
}
