﻿using System;
using System.Collections.Generic;
using System.Text;

namespace NHibernate_SGF.Entities
{
    /// <summary>
    /// Sesión de formación
    /// </summary>
    public class Sesion
    {
        private int intIdint;
        private int intNumero;
        private DateTime dtFechaInicio;
        private DateTime dtFechaFin;
        private string strUbicacion;
        private int intDuracionMinutos;
        private Edicion objEdicion;
        private IList<Asistencia> lstAsistencias;

        /// <summary>
        /// Constructor
        /// </summary>
        public Sesion() {
            this.Edicion = new Edicion();
            this.lstAsistencias = new List<Asistencia>();
        }

        /// <summary>
        /// Identificador
        /// </summary>
        public virtual int Idint
        {
            get { return intIdint; }
            set { intIdint = value; }
        }

        /// <summary>
        /// Orden de la sesión dentro de su edición
        /// </summary>
        public virtual int Numero
        {
            get { return intNumero; }
            set { intNumero = value; }
        }

        /// <summary>
        /// Fecha de inicio
        /// </summary>
        public virtual DateTime FechaInicio
        {
            get { return dtFechaInicio; }
            set { dtFechaInicio = value; }
        }

        /// <summary>
        /// Fecha de fin
        /// </summary>
        public virtual DateTime FechaFin
        {
            get { return dtFechaFin; }
            set { dtFechaFin = value; }
        }

        /// <summary>
        /// Ubicación
        /// </summary>
        public virtual string Ubicacion
        {
            get { return strUbicacion; }
            set { strUbicacion = value; }
        }

        /// <summary>
        /// Duración en minutos
        /// </summary>
        public virtual int DuracionMinutos
        {
            get { return intDuracionMinutos; }
            set { intDuracionMinutos = value; }
        }

        /// <summary>
        /// Edición a la que pertenece la sesión
        /// </summary>
        public virtual Edicion Edicion
        {
            get { return objEdicion; }
            set { objEdicion = value; }
        }

        /// <summary>
        /// Lista de asistencias de los empleados a la sesión
        /// </summary>
        public virtual IList<Asistencia> Asistencias
        {
            get { return lstAsistencias; }
            set { lstAsistencias = value; }
        }
    }
}
