﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NHibernate_SGF.Entities;
using Common.Log;

namespace NHibernate_SGF.Services
{
    /// <summary>
    /// Proveedor de acceso básico a los datos de todas las entidades
    /// </summary>
    public class MasterService
    {
        /// <summary>
        /// Inserta el objeto indicado en la base de datos
        /// </summary>
        /// <param name="objeto">Objeto a insertar</param>
        public static void Insertar(Object objeto)
        {
            LogFactory.Escribir().Info("Inicio");

            SessionManager.Instance.GetSession().Save(objeto);
            SessionManager.Instance.CommitTransaction();

            LogFactory.Escribir().Info("Fin");
        }

        /// <summary>
        /// Actualiza el objeto indicado en la base de datos o lo inserta en caso de que no exista previamente
        /// </summary>
        /// <param name="objeto">Objeto a actualizar</param>
        public static void Actualizar(Object objeto)
        {
            LogFactory.Escribir().Info("Inicio");
            
            try
            {
                //SessionManager.Instance.GetSession().Update(objeto);
                SessionManager.Instance.GetSession().Merge(objeto);
            }
            catch (NHibernate.NonUniqueObjectException exp)
            {
                LogFactory.Escribir().Warn(exp.GetType() + " - " + exp.EntityName + " - " + exp.Identifier);
                SessionManager.Instance.GetSession().SaveOrUpdateCopy(objeto);
            }
            SessionManager.Instance.CommitTransaction();

            LogFactory.Escribir().Info("Fin");
        }

        /// <summary>
        /// Elimina el objeto indicado en la base de datos
        /// </summary>
        /// <param name="objeto">Objeto a eliminar</param>
        public static void Eliminar(Object objeto)
        {
            LogFactory.Escribir().Info("Inicio");

            SessionManager.Instance.GetSession().Delete(objeto);
            SessionManager.Instance.CommitTransaction();

            LogFactory.Escribir().Info("Fin");
        }
    }
}

