﻿
namespace NHibernate_SGF
{
    /// <summary>
    /// Vinculación entre la base de datos, nhibernate y la aplicación
    /// </summary>
    public class SessionFactory
    {
        private static NHibernate.ISessionFactory objSessionFactory;

        /// <summary>
        /// Inicializa la vinculación
        /// </summary>
        private static void Inicializar()
        {
            NHibernate.Cfg.Configuration config = new NHibernate.Cfg.Configuration();
            config.Configure();
            objSessionFactory = config.BuildSessionFactory();
        }

        /// <summary>
        /// Obtiene la factoria nhibernate
        /// </summary>
        /// <returns>Factoria nhibernate</returns>
        public static NHibernate.ISessionFactory ObtenerSessionFactory()
        {
            if (objSessionFactory == null)
            {
                Inicializar();
            }
            return objSessionFactory;

        }

        /// <summary>
        /// Obtiene una sesión para acceder a la base de datos
        /// </summary>
        /// <returns>Sesión para acceder a la base de datos</returns>
        public static NHibernate.ISession AbrirSesion()
        {
            return ObtenerSessionFactory().OpenSession();
        }

    }
}
