select 
	empl_idint,
	empl_dni,
	empl_nombre,
	empl_apellidos,
	curs_idint,
	curs_nombre,
	case curs_tipo
		when 'C' then 'Central'
		when 'L' then 'Local'
		when 'O' then 'Otros'
	end TipoCurso,
	case
		when emcu_exento=1 then 'Si'
		when max(case when conv_completado != 0 then edic_fecha_fin else null end) is null then 'No'
		when curs_periodicidad_meses!=0 and DATEADD(MM,curs_periodicidad_meses,max(case when conv_completado != 0 then edic_fecha_fin else null end))<SYSDATETIME() then 'No'
		else 'Si'
		end Completado,
	case
		when emcu_exento=1 then 'Exento'
		when max(Convert(INT,conv_completado)) is null then 'No Convocado'
		when max(case when conv_completado = 1 then edic_fecha_fin else null end) is null And (max(case when conv_completado = 0 then edic_fecha_fin else null end)>=SYSDATETIME()) then 'Convocado'
		when max(case when conv_completado = 1 then edic_fecha_fin else null end) is null And (max(case when conv_completado = 0 then edic_fecha_fin else null end)<SYSDATETIME()) then 'No Superado'
		when max(case when conv_completado = 1 then edic_fecha_fin else null end) is not null And curs_periodicidad_meses!=0 And (DATEADD(MM, curs_periodicidad_meses, max(case when conv_completado != 0 then edic_fecha_fin else null end))<SYSDATETIME()) then 'Obsoleto'
		else 'Superado' end Estado,
	max(case when conv_completado != 0 then edic_fecha_fin else null end) FechaRealizacion,
	case
		when emcu_exento=1 then null
		when max(case when conv_completado != 0 then edic_fecha_fin else null end) is null and curs_incorporacion_meses!=0 and curs_periodicidad_meses=0 then DATEADD(MM, curs_incorporacion_meses, emcu_fecha_asignacion)
		when max(case when conv_completado != 0 then edic_fecha_fin else null end) is null and curs_incorporacion_meses=0 and curs_periodicidad_meses!=0 then DATEADD(MM, curs_periodicidad_meses, emcu_fecha_asignacion)
		when max(case when conv_completado != 0 then edic_fecha_fin else null end) is null and curs_incorporacion_meses!=0 and curs_periodicidad_meses!=0 then DATEADD(MM, (case when curs_incorporacion_meses<curs_periodicidad_meses then curs_incorporacion_meses else curs_periodicidad_meses end), emcu_fecha_asignacion)
		when max(case when conv_completado != 0 then edic_fecha_fin else null end) is not null and curs_periodicidad_meses!=0 then DATEADD(MM, curs_periodicidad_meses, max(case when conv_completado != 0 then edic_fecha_fin else null end))
		end FechaLimite
  from Empleados inner join EmpleadosCursos on empl_idint=emcu_empl_idint
	inner join Cursos on emcu_curs_idint=curs_idint
	left outer join Versiones on curs_idint=vers_curs_idint
	left outer join Ediciones on vers_idint=edic_vers_idint
	left outer join Convocatorias on edic_idint=conv_edic_idint and empl_idint=conv_empl_idint
where curs_fecha_baja is null
  and empl_fecha_baja is null
  and (curs_repetir_con_nueva_version=0 or vers_fecha_baja is null)
group by empl_idint, empl_dni, empl_nombre, empl_apellidos, empl_fecha_ingreso, emcu_exento, curs_idint, curs_nombre, curs_tipo, curs_periodicidad_meses, curs_incorporacion_meses, emcu_fecha_asignacion